/*********************************************************************************
	f[^x[XǗCuɂ{`
*********************************************************************************/

#ifndef ADBMBASE_H
#define ADBMBASE_H

/* OS */
#ifdef _WIN16
#	error Not Implemented
#elif defined _WIN32
#	define ADBM_WINDOWS
#	define ADBM_32BIT
#elif defined _WIN64
#	define ADBM_WINDOWS
#	define ADBM_64BIT
#else
#	error Not Implemented
#endif

/* GfBA */
/*
#define ADBM_BIG_ENDIAN
*/

/* fobO[h */
#if ( defined _DEBUG ) || !( defined NDEBUG )
#	define ADBM_DEBUG
#endif
#ifndef ADBM_ASSERT
#	define ADBM_ASSERT( expression )	assert( expression )
#endif
#ifdef ADBM_DEBUG
#	define ADBM_VERIFY( expression )	ADBM_ASSERT( expression )
#else
#	define ADBM_VERIFY( expression )	( (void)( expression ) )
#endif

/* G[R[h */
/*
	I0AȂ̃G[͐ł邱ƂۏႵ܂B
*/
typedef enum tagADBM_ERROR
{
	ADBM_ERR_NOT_IMPLEMENTED	= -1,	/*  */
	ADBM_ERR_SUCCESS			= 0,	/* I */
	ADBM_ERR_GENERAL,
	ADBM_ERR_INVALID_PARAM,
	ADBM_ERR_USER_CANSEL,
	ADBM_ERR_ABORT,
	ADBM_ERR_ALREADY_EXISTS,
	ADBM_ERR_NOT_SUPPORTED,
	ADBM_ERR_NOT_FOUND,
} ADBM_ERROR ;

/* nbVASY */
typedef enum tagADBM_HASHALGORITHM
{
	ADBM_HA_CRC16,
	ADBM_HA_CRC32,
	ADBM_HA_MD5,
	ADBM_HA_SHA1,
	ADBM_HA_SHA256,
	ADBM_HA_SHA384,
	ADBM_HA_SHA512,
	ADBM_HA_RIPEMD128,
	ADBM_HA_RIPEMD160,
	ADBM_HA_RIPEMD256,
	ADBM_HA_RIPEMD320,
} ADBM_HASHALGORITHM ;

/* f[^^ */
typedef	signed char			ADBM_INT8, * ADBM_PINT8 ;		/* L 8rbg */
typedef	unsigned char		ADBM_UINT8, * ADBM_PUINT8 ;		/*  8rbg */
typedef	signed short		ADBM_INT16, * ADBM_PINT16 ;		/* L16rbg */
typedef	unsigned short		ADBM_UINT16, * ADBM_PUINT16 ;	/* 16rbg */
typedef	signed long			ADBM_INT32, * ADBM_PINT32 ;		/* L32rbg */
typedef	unsigned long		ADBM_UINT32, * ADBM_PUINT32 ;	/* 32rbg */
typedef	signed __int64		ADBM_INT64, * ADBM_PINT64 ;		/* L64rbg */
typedef	unsigned __int64	ADBM_UINT64, * ADBM_PUINT64 ;	/* 64rbg */
typedef	signed int			ADBM_INT, * ADBM_PINT ;			/* L萮 */
typedef	unsigned int		ADBM_UINT, * ADBM_PUINT ;		/*  */
typedef	size_t				ADBM_SIZE_T, * ADBM_PSIZE_T ;	/*  */

typedef	char				ADBM_CHAR ;						/*  */
typedef	ADBM_CHAR			* ADBM_STR ;					/*  */
typedef const ADBM_CHAR		* ADBM_CSTR ;					/* (ǂݎp) */

typedef	ADBM_UINT8			ADBM_BYTE ;						/* oCgf[^ */
typedef	ADBM_UINT16			ADBM_WORD ;						/* [hf[^ */
typedef	ADBM_UINT32			ADBM_DWORD ;					/* _u[hf[^ */

typedef	int					ADBM_BOOL ;						/* _l */
#define ADBM_TRUE			( !(ADBM_FALSE) )				/* ^(0) */
#define ADBM_FALSE			0								/* U(0) */

#ifdef ADBM_32BIT
typedef	ADBM_INT32			ADBM_INT_PTR ;					/* |C^i[ł镄L萮 */
typedef	ADBM_UINT32			ADBM_UINT_PTR ;					/* |C^i[ł镄 */
#elif defined ADBM_64BIT
typedef	ADBM_INT64			ADBM_INT_PTR ;					/* |C^i[ł镄L萮 */
typedef	ADBM_UINT64			ADBM_UINT_PTR ;					/* |C^i[ł镄 */
#endif
typedef	ADBM_INT_PTR		ADBM_PARAM ;					/* ėp */

/* GUID \ */
typedef struct tagADBM_GUID
{
    ADBM_DWORD	data1 ;
    ADBM_WORD	data2 ;
    ADBM_WORD	data3 ;
    ADBM_BYTE	data4[8] ;
} ADBM_GUID, * ADBM_PGUID ;
typedef const ADBM_GUID		* ADBM_PCGUID ;
#define ADBM_GUID_EQUAL( pGUID1, pGUID2 )	( !memcmp( (pGUID1), (pGUID2), sizeof(ADBM_GUID) ) )

/* r֐(strcmp݊) */
typedef int (* ADBM_STRCMP)( const char * pszStr1, const char * pszStr2 ) ;

/* r֐ */
/*
	߂lɂ́A
		f[^P  f[^Q Ȃ 
		f[^P  f[^Q Ȃ O
		f[^P  f[^Q Ȃ 
	ԂĂB
	pData1ApData2 ɂ͏ɗLȃAhXn܂A
	f[^ƂėLȔ͈͂́Aꂼ size1Asize2 ŕ\܂B
	size1Asize2 0łꍇ܂B
*/
typedef ADBM_INT (* ADBM_COMPARE)( const void * pData1, ADBM_SIZE_T size1, const void * pData2, ADBM_SIZE_T size2 ) ;

/* r֐ID */
extern const ADBM_GUID			ADBM_FNCID_MEMCMP ;			/* r */
extern const ADBM_GUID			ADBM_FNCID_RMEMCMP ;		/* r(]) */
extern const ADBM_GUID			ADBM_FNCID_STRCMP ;			/* r */
extern const ADBM_GUID			ADBM_FNCID_RSTRCMP ;		/* r(]) */
extern const ADBM_GUID			ADBM_FNCID_ICSTRCMP ;		/* P[X𖳎r */
extern const ADBM_GUID			ADBM_FNCID_RICSTRCMP ;		/* P[X𖳎r(]) */

/* r֐ID|C^ */
#define ADBM_PFNCID_MEMCMP		( &ADBM_FNCID_MEMCMP )		/* r */
#define ADBM_PFNCID_RMEMCMP		( &ADBM_FNCID_RMEMCMP )		/* r(]) */
#define ADBM_PFNCID_STRCMP		( &ADBM_FNCID_STRCMP )		/* r */
#define ADBM_PFNCID_RSTRCMP		( &ADBM_FNCID_RSTRCMP )		/* r(]) */
#define ADBM_PFNCID_ICSTRCMP	( &ADBM_FNCID_ICSTRCMP )	/* P[X𖳎r */
#define ADBM_PFNCID_RICSTRCMP	( &ADBM_FNCID_RICSTRCMP )	/* P[X𖳎r(]) */

/* ėpR[obN֐ */
/*
	R[obN@\֐(ȉAFunc)́ÄƂāA
	{ɏ]R[obN֐̃|C^(ȉAcallBack)ƁA
	[U[`f[^̃|C^(ȉApUserData)܂B
	callBack  NULL łȂ΁AFunc ͏̓rŒI callBack Ăяo܂B
	̂Ƃ callBack ɂ́AFunc ɓn pUserData ̒lƁA
	̓(ȉAfuncInfo)n܂B
	funcInfo ɂǂ̂悤ȃf[^n邩́A֐Ƃ̃t@XQƂB
	Func ɑ΂A̒fwɂ́AR[obN֐ ADBM_FALSE Ԃ܂B
	 Func ͏ł؂A߂lƂ ADBM_ERR_USER_CANSEL Ԃ܂B
	ڂf𓾂ɂ́ApUserData ȂǂpĐff@\܂B
*/
typedef ADBM_BOOL (* ADBM_CALLBACK)( void * pUserData, ADBM_PARAM funcInfo ) ;

#endif
