/*********************************************************************************
	nbV API
*********************************************************************************/

#ifndef API_HASH_H
#define API_HASH_H

#ifndef IMPLEMENT_ADBM
#	define ADBM_PREFIX	ADBM_IMPORT
#elif ! defined IMPLEMENT_API_HASH
#	define ADBM_PREFIX	extern
#else
#	define ADBM_PREFIX	ADBM_EXPORT
#endif

#ifdef __cplusplus
extern "C"
{
#endif

/* w肵nbVASYĂ邩ǂׂ */
ADBM_PREFIX ADBM_BOOL ADBM_API hashIsImplemented( ADBM_HASHALGORITHM hashAlgorithm ) ;

/* nbVASYC^[tFCX擾 */
ADBM_PREFIX ADBM_HHASH ADBM_API hashGetAlgorithm( ADBM_HASHALGORITHM hashAlgorithm ) ;

/* f[^͂ */
ADBM_PREFIX ADBM_ERROR ADBM_API hashInput( ADBM_HHASH hHash, const void * pData, ADBM_SIZE_T length ) ;

/* nbVTCY擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API hashGetSize( ADBM_HHASH hHash ) ;

/* nbV擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API hashGet( ADBM_HHASH hHash, void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/*  */
ADBM_PREFIX void ADBM_API hashInit( ADBM_HHASH hHash ) ;

/* nbVASYC^[tFCXJ */
ADBM_PREFIX void ADBM_API hashReleaseAlgorithm( ADBM_HHASH hHash ) ;

/* nbVnbVɕϊ */
ADBM_PREFIX ADBM_ERROR ADBM_API hashHashToString(
	const void * pHash, ADBM_SIZE_T hashSize,
	ADBM_STR pBuffer, ADBM_SIZE_T bufferSize, ADBM_BOOL bLower ) ;

/* nbV񂩂nbVɕϊ */
ADBM_PREFIX ADBM_ERROR ADBM_API hashStringToHash(
	ADBM_CSTR pszHash,
	void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/* w肵ASYɂnbVTCY擾 */
ADBM_PREFIX ADBM_UINT32 ADBM_API hashGetHashSize( ADBM_HASHALGORITHM hashAlgorithm ) ;

/* ASYw肵ăt@C̃nbV擾 */
/*
	calcLength 0w肵ꍇAt@C̏I[܂ŌvZ܂B
	R[obNĂяoł́A\łc̃t@C(byte) funcInfo ɓn܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API hashGetFileHash(
	ADBM_CSTR pszFilePath, ADBM_SIZE_T calcLength, ADBM_HASHALGORITHM hashAlgorithm,
	void * pBuffer, ADBM_SIZE_T bufferSize,
	ADBM_CALLBACK callBack, void * pUserData ) ;

/* ASYw肵ăɂf[^̃nbV擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API hashGetDataHash(
	const void * pData, ADBM_SIZE_T length, ADBM_HASHALGORITHM hashAlgorithm,
	void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/* ASYw肵ĕ̃nbV擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API hashGetTextHash(
	ADBM_CSTR pszText, ADBM_HASHALGORITHM hashAlgorithm,
	void * pBuffer, ADBM_SIZE_T bufferSize ) ;

/* ASYw肵ăt@C̃nbV擾 */
/*
	calcLength 0w肵ꍇAt@C̏I[܂ŌvZ܂B
	R[obNĂяoł́A\łc̃t@C(byte) funcInfo ɓn܂B
*/
ADBM_PREFIX ADBM_ERROR ADBM_API hashGetFileStrHash(
	ADBM_CSTR pszFilePath, ADBM_SIZE_T calcLength, ADBM_HASHALGORITHM hashAlgorithm,
	ADBM_STR pBuffer, ADBM_SIZE_T bufferSize, ADBM_BOOL bLower,
	ADBM_CALLBACK callBack, void * pUserData ) ;

/* ASYw肵ăɂf[^̃nbV擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API hashGetDataStrHash(
	const void * pData, ADBM_SIZE_T length, ADBM_HASHALGORITHM hashAlgorithm,
	ADBM_STR pBuffer, ADBM_SIZE_T bufferSize, ADBM_BOOL bLower ) ;

/* ASYw肵ĕ̃nbV擾 */
ADBM_PREFIX ADBM_ERROR ADBM_API hashGetTextStrHash(
	ADBM_CSTR pszText, ADBM_HASHALGORITHM hashAlgorithm,
	ADBM_STR pBuffer, ADBM_SIZE_T bufferSize, ADBM_BOOL bLower ) ;

#ifdef __cplusplus
}
#endif

#undef ADBM_PREFIX

#endif
