#include <adbm.h>
#include <stdio.h>
#include <assert.h>

#include "cmd.h"
#include "fileinfo_main.h"
#include "attinfo_main.h"

/* R}hnh */
static int OnGetLibraryID( HCMD hCmd, void * pUserData ) ;
static int OnGetLibraryVersion( HCMD hCmd, void * pUserData ) ;
static int OnShowAttList( HCMD hCmd, void * pUserData ) ;
static int OnCreate( HCMD hCmd, void * pUserData ) ;
static int OnIsSupported( HCMD hCmd, void * pUserData ) ;
static int OnGetDBVersion( HCMD hCmd, void * pUserData ) ;
static int OnGetDBInfoSize( HCMD hCmd, void * pUserData ) ;
static int OnGetDBInfo( HCMD hCmd, void * pUserData ) ;
static int OnAttach( HCMD hCmd, void * pUserData ) ;
static int OnDetach( HCMD hCmd, void * pUserData ) ;
static int OnGetMaxPath( HCMD hCmd, void * pUserData ) ;
static int OnGetMaxFileAttNum( HCMD hCmd, void * pUserData ) ;
static int OnGetMaxCommentLength( HCMD hCmd, void * pUserData ) ;
static int OnGetAttExtraDataSize( HCMD hCmd, void * pUserData ) ;
static int OnGetFileExtraDataSize( HCMD hCmd, void * pUserData ) ;
static int OnGetHashSize( HCMD hCmd, void * pUserData ) ;
static int OnGetMaxAttNameLength( HCMD hCmd, void * pUserData ) ;
static int OnIsOpened( HCMD hCmd, void * pUserData ) ;
static int OnOpen( HCMD hCmd, void * pUserData ) ;
static int OnClose( HCMD hCmd, void * pUserData ) ;
static int OnIsWriteAccess( HCMD hCmd, void * pUserData ) ;
static int OnAttInfoAdd( HCMD hCmd, void * pUserData ) ;
static int OnAttInfoGetID( HCMD hCmd, void * pUserData ) ;
static int OnAttInfoOpen( HCMD hCmd, void * pUserData ) ;
static int OnAttInfoDelete( HCMD hCmd, void * pUserData ) ;
static int OnFileInfoAdd( HCMD hCmd, void * pUserData ) ;
static int OnFileInfoGetIDByPath( HCMD hCmd, void * pUserData ) ;
static int OnFileInfoOpen( HCMD hCmd, void * pUserData ) ;
static int OnFileInfoDelete( HCMD hCmd, void * pUserData ) ;
static int OnFindAtt( HCMD hCmd, void * pUserData ) ;
static int OnFindFile( HCMD hCmd, void * pUserData ) ;
static int OnQuit( HCMD hCmd, void * pUserData ) ;

/* R}h}bv */
static const CMDINFO c_cmdMap[] =
{
	{ "libid", OnGetLibraryID },
	{ "libver", OnGetLibraryVersion },
	{ "showattlist", OnShowAttList },
	{ "create", OnCreate },
	{ "supportok", OnIsSupported },
	{ "dbver", OnGetDBVersion },
	{ "infosize", OnGetDBInfoSize },
	{ "info", OnGetDBInfo },
	{ "attach", OnAttach },
	{ "detach", OnDetach },
	{ "maxpath", OnGetMaxPath },
	{ "maxattnum", OnGetMaxFileAttNum },
	{ "maxcomment", OnGetMaxCommentLength },
	{ "aexsize", OnGetAttExtraDataSize },
	{ "fexsize", OnGetFileExtraDataSize },
	{ "hashsize", OnGetHashSize },
	{ "maxattname", OnGetMaxAttNameLength },
	{ "connectok", OnIsOpened },
	{ "open", OnOpen },
	{ "close", OnClose },
	{ "writeok", OnIsWriteAccess },
	{ "aiadd", OnAttInfoAdd },
	{ "aigetid", OnAttInfoGetID },
	{ "aiopen", OnAttInfoOpen },
	{ "aidelete", OnAttInfoDelete },
	{ "fiadd", OnFileInfoAdd },
	{ "figetid", OnFileInfoGetIDByPath },
	{ "fiopen", OnFileInfoOpen },
	{ "fidelete", OnFileInfoDelete },
	{ "findatt", OnFindAtt },
	{ "findfile", OnFindFile },
	{ "quit", OnQuit },
} ;

/* Xgۑ */
static void SaveAttList( ADBM_HADB hADB ) ;

/* Xg\ */
static void ShowAttList( void ) ;

/* adb_main pf[^\ */
typedef struct tagADBDATA
{
	ADBM_HADB	hADB ;
} ADBDATA, * PADBDATA ;

/* Xgt@C */
/*
	gUNVReLXgɊւeXgpt@CB
	Ōɑ̕ҏWsꂽf[^x[XێĂ鑮̃XgB
	showattlist R}hœemFłB
	close 1Aclose 0 Ńf[^x[XƋɃR~bgA[obN̂mFׂB
*/
static const char *	c_pszAttList = "attlist.txt" ;

/* f[^x[X */
void adb_main( void )
{
	ADBDATA	data ;

	data.hADB = NULL ;
	cmd_loop( "adb>", c_cmdMap, sizeof(c_cmdMap)/sizeof(CMDINFO), &data ) ;
	if ( data.hADB != NULL )
		adbDetach( data.hADB ) ;
}

/* R}hnh */
#ifndef UNUSED
#define UNUSED( x )	x
#endif
static int OnGetLibraryID( HCMD hCmd, void * pUserData )
{
	ADBM_GUID	libID ;

	UNUSED( hCmd ) ;
	UNUSED( pUserData ) ;
	adbGetLibraryID( &libID ) ;
	printf( "%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x\n",
		libID.data1, libID.data2, libID.data3, libID.data4[0], libID.data4[1],
		libID.data4[2], libID.data4[3], libID.data4[4], libID.data4[5], libID.data4[6], libID.data4[7] ) ;
	return 0 ;
}
static int OnGetLibraryVersion( HCMD hCmd, void * pUserData )
{
	ADBM_DWORD	version = adbGetLibraryVersion() ;

	UNUSED( hCmd ) ;
	UNUSED( pUserData ) ;
	printf( "%d.", ( version >> 24 ) & 0x000000FF ) ;
	printf( "%d.", ( version >> 16 ) & 0x000000FF ) ;
	printf( "%d.", ( version >> 8 ) & 0x000000FF ) ;
	printf( "%d\n", ( version >> 0 ) & 0x000000FF ) ;
	return 0 ;
}
static int OnShowAttList( HCMD hCmd, void * pUserData )
{
	UNUSED( hCmd ) ;
	UNUSED( pUserData ) ;
	ShowAttList() ;
	return 0 ;
}
static int OnCreate( HCMD hCmd, void * pUserData )
{
	ADBM_CSTR		pszADBDirPath = NULL ;
	const char *	pDBInfo = "test_adbm" ;

	UNUSED( pUserData ) ;
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tf[^x[XfBNgpX(K{)\n" ) ;
		return 0 ;
	}
	pszADBDirPath = cmd_argv( hCmd, 1 ) ;
	if ( !adbCreate(
		pszADBDirPath, _MAX_PATH+1, 256, 512, 0, 0, 0, 256,
		ADBM_PFNCID_ICSTRCMP, pDBInfo, (ADBM_UINT32)strlen(pDBInfo)+1 ) )
		printf( "\n" ) ;
	else
		printf( "s\n" ) ;
	return 0 ;
}
static int OnIsSupported( HCMD hCmd, void * pUserData )
{
	UNUSED( pUserData ) ;
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tf[^x[XfBNgpX(K{)\n" ) ;
		return 0 ;
	}
	if ( adbIsSupported( cmd_argv(hCmd,1) ) )
		printf( "yes\n" ) ;
	else
		printf( "no\n" ) ;
	return 0 ;
}
static int OnGetDBVersion( HCMD hCmd, void * pUserData )
{
	ADBM_DWORD	version ;

	UNUSED( pUserData ) ;
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tf[^x[XfBNgpX(K{)\n" ) ;
		return 0 ;
	}
	version = adbGetDBVersion( cmd_argv(hCmd,1) ) ;
	UNUSED( hCmd ) ;
	printf( "%d.", ( version >> 24 ) & 0x000000FF ) ;
	printf( "%d.", ( version >> 16 ) & 0x000000FF ) ;
	printf( "%d.", ( version >> 8 ) & 0x000000FF ) ;
	printf( "%d\n", ( version >> 0 ) & 0x000000FF ) ;
	return 0 ;
}
static int OnGetDBInfoSize( HCMD hCmd, void * pUserData )
{
	UNUSED( pUserData ) ;
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tf[^x[XfBNgpX(K{)\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetDBInfoSize( cmd_argv(hCmd,1) ) ) ;
	return 0 ;
}
static int OnGetDBInfo( HCMD hCmd, void * pUserData )
{
	UNUSED( pUserData ) ;
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tf[^x[XfBNgpX(K{)\n" ) ;
		return 0 ;
	}

	{
		char	buffer[256] ;
		if ( !adbGetDBInfo( cmd_argv(hCmd,1), buffer, sizeof(buffer) ) )
			printf( "%s\n", buffer ) ;
	}
	return 0 ;
}
static int OnAttach( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tf[^x[XfBNgpX(K{)\n" ) ;
		return 0 ;
	}

	if ( pData->hADB != NULL )
		adbDetach( pData->hADB ) ;
	pData->hADB = adbAttach( cmd_argv(hCmd,1), ADBM_PFNCID_ICSTRCMP, NULL ) ;
	if ( pData->hADB != NULL )
		printf( "\n" ) ;
	else
		printf( "s\n" ) ;
	return 0 ;
}
static int OnDetach( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
		return 0 ;
	adbDetach( pData->hADB ) ;
	pData->hADB = NULL ;
	return 0 ;
}
static int OnGetMaxPath( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetMaxPath( pData->hADB ) ) ;
	return 0 ;
}
static int OnGetMaxFileAttNum( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetMaxFileAttNum( pData->hADB ) ) ;
	return 0 ;
}
static int OnGetMaxCommentLength( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetMaxCommentLength( pData->hADB ) ) ;
	return 0 ;
}
static int OnGetAttExtraDataSize( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetAttExtraDataSize( pData->hADB ) ) ;
	return 0 ;
}
static int OnGetFileExtraDataSize( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetFileExtraDataSize( pData->hADB ) ) ;
	return 0 ;
}
static int OnGetHashSize( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetHashSize( pData->hADB ) ) ;
	return 0 ;
}
static int OnGetMaxAttNameLength( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	printf( "%d\n", adbGetMaxAttNameLength( pData->hADB ) ) ;
	return 0 ;
}
static int OnIsOpened( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( adbIsOpened( pData->hADB ) )
		printf( "yes\n" ) ;
	else
		printf( "no\n" ) ;
	return 0 ;
}
static int OnOpen( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;
	ADBM_BOOL	bWriteAccess ;
	ADBM_UINT32	waitTime = 0xFFFFFFFF ;
	int			argc = cmd_argc( hCmd ) ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( adbIsOpened( pData->hADB ) )
	{
		printf( "ɃRlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( argc < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t݃ANZXtO(K{)\n" ) ;
		printf( "2:\tRlNVI[vҋ@~bg\n" ) ;
		return 0 ;
	}
	bWriteAccess = atoi( cmd_argv(hCmd,1) ) ;
	if ( argc > 2 )
		waitTime = atoi( cmd_argv(hCmd,2) ) ;
	if ( adbOpen( pData->hADB, bWriteAccess, waitTime ) )
		printf( "\n" ) ;
	else
		printf( "s\n" ) ;
	return 0 ;
}
static int OnClose( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;
	ADBM_BOOL	bCommit = ADBM_TRUE ;

	if ( pData->hADB == NULL )
		return 0 ;
	if ( cmd_argc(hCmd) > 1 )
		bCommit = atoi( cmd_argv(hCmd,1) ) ;
	adbClose( pData->hADB, bCommit ) ;
	return 0 ;
}
static int OnIsWriteAccess( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( adbIsWriteAccess( pData->hADB ) )
		printf( "yes\n" ) ;
	else
		printf( "no\n" ) ;
	return 0 ;
}
static int OnAttInfoAdd( HCMD hCmd, void * pUserData )
{
	PADBDATA			pData = (PADBDATA)pUserData ;
	ADBM_UINT32			attID ;
	ADBM_REGISTERRESULT	rr ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsWriteAccess( pData->hADB ) )
	{
		printf( "݃ANZX܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t(K{)\n" ) ;
		return 0 ;
	}
	rr = adbAttInfoAdd( pData->hADB, cmd_argv(hCmd,1), &attID ) ;
	if ( ADBM_RFAILED( rr ) )
	{
		printf( "s\n" ) ;
		return 0 ;
	}
	if ( rr & ADBM_RRB_EXIST_ATT )
		printf( "o^ς(IDF%d)\n", attID ) ;
	else
	{
		printf( "(IDF%d)\n", attID ) ;
		SaveAttList( pData->hADB ) ;
	}
	return 0 ;
}
static int OnAttInfoGetID( HCMD hCmd, void * pUserData )
{
	PADBDATA		pData = (PADBDATA)pUserData ;
	ADBM_UINT32		attID ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t(K{)\n" ) ;
		return 0 ;
	}
	attID = adbAttInfoGetID( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( attID != 0 )
		printf( "IDF%d\n", attID ) ;
	else
		printf( "o^\n" ) ;
	return 0 ;
}
static int OnAttInfoOpen( HCMD hCmd, void * pUserData )
{
	PADBDATA		pData = (PADBDATA)pUserData ;
	ADBM_UINT32		attID ;
	ADBM_HATTINFO	hAttInfo ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 3 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t(K{)\n" ) ;
		printf( "2:\t݃ANZXtO(K{)\n" ) ;
		return 0 ;
	}
	attID = adbAttInfoGetID( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( attID == 0 )
	{
		printf( "w肳ꂽ͓̂̑o^Ă܂\n" ) ;
		return 0 ;
	}
	hAttInfo = adbAttInfoOpen( pData->hADB, attID, atoi(cmd_argv(hCmd,2)) ) ;
	if ( hAttInfo == NULL )
	{
		printf( "ւ̃C^[tFCXJ܂ł\n" ) ;
		return 0 ;
	}

	/* 񑀍 */
	attinfo_main( pData->hADB, hAttInfo ) ;
	adbAttInfoClose( pData->hADB, hAttInfo ) ;
	if ( atoi(cmd_argv(hCmd,2)) )
		SaveAttList( pData->hADB ) ;
	return 0 ;
}
static int OnAttInfoDelete( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;
	ADBM_UINT32	attID ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsWriteAccess( pData->hADB ) )
	{
		printf( "݃ANZX܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t(K{)\n" ) ;
		return 0 ;
	}
	attID = adbAttInfoGetID( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( attID == 0 )
	{
		printf( "w肳ꂽ͓̂̑o^Ă܂\n" ) ;
		return 0 ;
	}
	adbAttInfoDelete( pData->hADB, attID ) ;
	SaveAttList( pData->hADB ) ;
	return 0 ;
}
static int OnFileInfoAdd( HCMD hCmd, void * pUserData )
{
	PADBDATA			pData = (PADBDATA)pUserData ;
	ADBM_UINT32			fileID ;
	ADBM_REGISTERRESULT	rr ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsWriteAccess( pData->hADB ) )
	{
		printf( "݃ANZX܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tt@CpX(K{)\n" ) ;
		return 0 ;
	}
	rr = adbFileInfoAdd( pData->hADB, cmd_argv(hCmd,1), NULL, &fileID ) ;
	if ( ADBM_RFAILED( rr ) )
	{
		printf( "o^ɃG[܂\n" ) ;
		return 0 ;
	}
	printf( "(t@CIDF%d)\n", fileID ) ;
	if ( rr & ADBM_RRB_EXIST_PATH )
		printf( "o^ς݃pX\n" ) ;
	if ( rr & ADBM_RRB_EXIST_HASH )
		printf( "o^ς݃nbV(d)\n" ) ;
	if ( rr & ADBM_RRB_PATH_ENABLE )
		printf( "̕⊮\n" ) ;
	return 0 ;
}
static int OnFileInfoGetIDByPath( HCMD hCmd, void * pUserData )
{
	PADBDATA		pData = (PADBDATA)pUserData ;
	ADBM_UINT32		fileID ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tt@CpX(K{)\n" ) ;
		return 0 ;
	}
	fileID = adbFileInfoGetIDByPath( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( fileID != 0 )
		printf( "t@CIDF%d\n", fileID ) ;
	else
		printf( "o^\n" ) ;
	return 0 ;
}
static int OnFileInfoOpen( HCMD hCmd, void * pUserData )
{
	PADBDATA		pData = (PADBDATA)pUserData ;
	ADBM_UINT32		fileID ;
	ADBM_HFILEINFO	hFileInfo ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 3 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tt@CpX(K{)\n" ) ;
		printf( "2:\t݃ANZXtO(K{)\n" ) ;
		return 0 ;
	}
	fileID = adbFileInfoGetIDByPath( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( fileID == 0 )
	{
		printf( "w肳ꂽpX͓o^Ă܂\n" ) ;
		return 0 ;
	}
	hFileInfo = adbFileInfoOpen( pData->hADB, fileID, atoi(cmd_argv(hCmd,2)) ) ;
	if ( hFileInfo == NULL )
	{
		printf( "t@Cւ̃C^[tFCXJ܂ł\n" ) ;
		return 0 ;
	}

	/* t@C񑀍 */
	fileinfo_main( pData->hADB, hFileInfo ) ;
	adbFileInfoClose( pData->hADB, hFileInfo ) ;
	if ( atoi(cmd_argv(hCmd,2)) )
		SaveAttList( pData->hADB ) ;
	return 0 ;
}
static int OnFileInfoDelete( HCMD hCmd, void * pUserData )
{
	PADBDATA	pData = (PADBDATA)pUserData ;
	ADBM_UINT32	fileID ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsWriteAccess( pData->hADB ) )
	{
		printf( "݃ANZX܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\tt@CpX(K{)\n" ) ;
		return 0 ;
	}
	fileID = adbFileInfoGetIDByPath( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( fileID == 0 )
	{
		printf( "w肳ꂽpX͓o^Ă܂\n" ) ;
		return 0 ;
	}
	adbFileInfoDelete( pData->hADB, fileID, ADBM_FALSE ) ;
	return 0 ;
}
static int OnFindAtt( HCMD hCmd, void * pUserData )
{
	PADBDATA		pData = (PADBDATA)pUserData ;
	ADBM_HFINDATT	hFindAtt ;
	ADBM_UINT32		attNum, i ;

	UNUSED( hCmd ) ;
	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	hFindAtt = adbFindAttOpen( pData->hADB ) ;
	if ( hFindAtt == NULL )
	{
		printf( "񌟍C^[tFCXJ܂ł\n" ) ;
		return 0 ;
	}
	attNum = faGetNum( hFindAtt ) ;
	printf( "F%d\n", attNum ) ;
	for ( i = 0 ; i < attNum ; i ++ )
	{
		ADBM_HATTINFO	hAttInfo = faOpenAttInfo( hFindAtt ) ;
		if ( hAttInfo != NULL )
		{
			char	attName[256] ;
			if ( aiGetName( hAttInfo, attName, sizeof(attName) ) > 0 )
				printf( "%dF%s(ID %d, QƐ %d)\n",
					faGetIndex(hFindAtt), attName, aiGetID(hAttInfo), aiGetRefCount(hAttInfo) ) ;
			faCloseAttInfo( hFindAtt, hAttInfo ) ;
		}
		if ( faFindNext( hFindAtt, 1, ADBM_TRUE ) )
			break ;
	}
	adbFindAttClose( pData->hADB, hFindAtt ) ;
	return 0 ;
}
static int OnFindFile( HCMD hCmd, void * pUserData )
{
	PADBDATA		pData = (PADBDATA)pUserData ;
	ADBM_UINT32		attID ;
	ADBM_HFINDFILE	hFindFile ;
	ADBM_UINT32		fileNum, i ;

	if ( pData->hADB == NULL )
	{
		printf( "f[^x[X֘AtĂ܂\n" ) ;
		return 0 ;
	}
	if ( !adbIsOpened( pData->hADB ) )
	{
		printf( "f[^x[Xւ̃RlNVJĂ܂\n" ) ;
		return 0 ;
	}
	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t(K{)\n" ) ;
		return 0 ;
	}
	attID = adbAttInfoGetID( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( attID == 0 )
	{
		printf( "w肳ꂽ͓̂̑o^Ă܂\n" ) ;
		return 0 ;
	}
	hFindFile = adbFindFileOpen( pData->hADB, attID ) ;
	if ( hFindFile == NULL )
	{
		printf( "t@C񌟍C^[tFCXJ܂ł\n" ) ;
		return 0 ;
	}
	fileNum = ffGetNum( hFindFile ) ;
	printf( "t@CF%d\n", fileNum ) ;
	for ( i = 0 ; i < fileNum ; i ++ )
	{
		ADBM_HFILEINFO	hFileInfo = ffOpenFileInfo( hFindFile ) ;
		if ( hFileInfo != NULL )
		{
			ADBM_CHAR	path[_MAX_PATH+1] ;
			if ( fiGetPath( hFileInfo, path, sizeof(path) ) )
				printf( "%s\n", path ) ;
			ffCloseFileInfo( hFindFile, hFileInfo ) ;
		}
		if ( ffFindNext( hFindFile, 1, ADBM_TRUE ) )
			break ;
	}
	adbFindFileClose( pData->hADB, hFindFile ) ;
	return 0 ;
}
static int OnQuit( HCMD hCmd, void * pUserData )
{
	UNUSED( hCmd ) ;
	UNUSED( pUserData ) ;
	return -1 ;
}

/* Xgۑ */
static void SaveAttList( ADBM_HADB hADB )
{
	ADBM_HTC		hTC ;
	ADBM_HTFILE		hTFile ;

	/* gUNVReLXg擾 */
	hTC = adbGetTC( hADB ) ;
	assert( hTC != NULL ) ;
	assert( tcIsWriteAccess( hTC ) ) ;

	/* XgJăf[^x[XێĂ鑮o */
	tcCreateFile( hTC, c_pszAttList ) ;
	hTFile = tcOpenFile( hTC, c_pszAttList, ADBM_TRUE ) ;
	if ( hTFile != NULL )
	{
		ADBM_HFINDATT	hFindAtt = adbFindAttOpen( hADB ) ;
		if ( hFindAtt != NULL )
		{
			ADBM_UINT32	i, attNum = faGetNum( hFindAtt ) ;
			for ( i = 0 ; i < attNum ; i ++ )
			{
				ADBM_HATTINFO	hAttInfo = faOpenAttInfo( hFindAtt ) ;
				if ( hAttInfo != NULL )
				{
					char	attName[256] ;
					if ( aiGetName( hAttInfo, attName, sizeof(attName) ) > 0 )
					{
						tcFileWrite( hTFile, attName, (ADBM_UINT32)strlen(attName) ) ;
						tcFileWrite( hTFile, "\r\n", (ADBM_UINT32)strlen("\r\n") ) ;
					}
					adbAttInfoClose( hADB, hAttInfo ) ;
				}
				if ( faFindNext( hFindAtt, 1, ADBM_TRUE ) )
					break ;
			}
			adbFindAttClose( hADB, hFindAtt ) ;
		}
		tcFileSetEndOfFile( hTFile ) ;
		tcCloseFile( hTC, hTFile ) ;
	}

	/* gUNVReLXgJ */
	adbReleaseTC( hTC ) ;
}

/* sǂݍ */
static char * myfgets( char * pString, int n, FILE * fp )
{
	size_t	len ;

	if ( pString == NULL || n <= 0 || fp == NULL )
		return NULL ;
	if ( fgets( pString, n, fp ) == NULL )
		return NULL ;

	/* CRLF΍ */
	len = strlen( pString ) ;
	if ( len >= 2 )
	{
		if ( pString[len-2] == '\r' && pString[len-1] == '\n' )
			pString[len-2] = '\0' ;
	}

	return pString ;
}

/* Xg\ */
static void ShowAttList( void )
{
	char	attName[256] ;
	FILE *	fp = fopen( c_pszAttList, "rb" ) ;
	if ( fp == NULL )
		return ;
	while ( myfgets( attName, 256, fp ) != NULL )
		printf( "%s\n", attName ) ;
	fclose( fp ) ;
}

