#include <adbm.h>
#include <stdio.h>
#include <assert.h>

#include "cmd.h"

/* R}hnh */
static int OnGetID( HCMD hCmd, void * pUserData ) ;
static int OnGetRefCount( HCMD hCmd, void * pUserData ) ;
static int OnGetName( HCMD hCmd, void * pUserData ) ;
static int OnSetName( HCMD hCmd, void * pUserData ) ;
static int OnCombine( HCMD hCmd, void * pUserData ) ;
static int OnClose( HCMD hCmd, void * pUserData ) ;

/* R}h}bv */
static const CMDINFO c_cmdMap[] =
{
	{ "getid", OnGetID },
	{ "refc", OnGetRefCount },
	{ "getname", OnGetName },
	{ "setname", OnSetName },
	{ "combine", OnCombine },
	{ "close", OnClose },
} ;

/* attinfo_main pf[^\ */
typedef struct tagATTINFODATA
{
	ADBM_HADB		hADB ;
	ADBM_HATTINFO	hAttInfo ;
} ATTINFODATA, * PATTINFODATA ;

/* 񑀍 */
void attinfo_main( ADBM_HADB hADB, ADBM_HATTINFO hAttInfo )
{
	ATTINFODATA	data ;

	assert( hADB != NULL && hAttInfo != NULL ) ;
	data.hADB = hADB ;
	data.hAttInfo = hAttInfo ;
	cmd_loop( "attinfo>", c_cmdMap, sizeof(c_cmdMap)/sizeof(CMDINFO), &data ) ;
}

/* R}hnh */
#ifndef UNUSED
#define UNUSED( x )	x
#endif
static int OnGetID( HCMD hCmd, void * pUserData )
{
	PATTINFODATA	pData = (PATTINFODATA)pUserData ;

	UNUSED( hCmd ) ;
	printf( "%d\n", aiGetID( pData->hAttInfo ) ) ;
	return 0 ;
}
static int OnGetRefCount( HCMD hCmd, void * pUserData )
{
	PATTINFODATA	pData = (PATTINFODATA)pUserData ;

	UNUSED( hCmd ) ;
	printf( "%d\n", aiGetRefCount( pData->hAttInfo ) ) ;
	return 0 ;
}
static int OnGetName( HCMD hCmd, void * pUserData )
{
	PATTINFODATA	pData = (PATTINFODATA)pUserData ;
	ADBM_CHAR	buffer[256] ;

	UNUSED( hCmd ) ;
	if ( aiGetName( pData->hAttInfo, buffer, sizeof(buffer) ) )
		printf( "%s\n", buffer ) ;
	return 0 ;
}
static int OnSetName( HCMD hCmd, void * pUserData )
{
	PATTINFODATA	pData = (PATTINFODATA)pUserData ;

	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t(K{)\n" ) ;
		return 0 ;
	}
	if ( !aiSetName( pData->hAttInfo, cmd_argv(hCmd,1) ) )
		printf( "\n" ) ;
	else
		printf( "s\n" ) ;
	return 0 ;
}
static int OnCombine( HCMD hCmd, void * pUserData )
{
	PATTINFODATA	pData = (PATTINFODATA)pUserData ;
	ADBM_UINT32		srcAttID ;

	if ( cmd_argc( hCmd ) < 2 )
	{
		printf( "%s R}h\n", cmd_argv(hCmd,0) ) ;
		printf( "1:\t(K{)\n" ) ;
		return 0 ;
	}
	srcAttID = adbAttInfoGetID( pData->hADB, cmd_argv(hCmd,1) ) ;
	if ( srcAttID == 0 )
	{
		printf( "w肳ꂽ͓o^Ă܂\n" ) ;
		return 0 ;
	}
	if ( !aiCombine( pData->hAttInfo, srcAttID ) )
		printf( "\n" ) ;
	else
		printf( "s\n" ) ;
	return 0 ;
}
static int OnClose( HCMD hCmd, void * pUserData )
{
	UNUSED( hCmd ) ;
	UNUSED( pUserData ) ;
	return -1 ;
}

