#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "cmd.h"

#define BUFSIZE	4096
#define MAXARGC	256
#define IsSJISLeadByte( c )	( (unsigned)( (c)^0x20 ) - 0xA1 < 0x3C )

typedef struct tagCMD
{
	char *			pBuffer ;
	int				argc ;
	const char *	argv[MAXARGC] ;
} CMD, * HCMD ;

static HCMD cmd_get( void )
{
	HCMD	hCmd = NULL ;
	int		bRead, bDQuate, i ;

	/* mۂăR}hCsǂݍ */
	hCmd = (HCMD)calloc( 1, sizeof(CMD) ) ;
	if ( hCmd == NULL )
		goto _ERROR ;
	hCmd->pBuffer = (char *)calloc( 1, BUFSIZE ) ;
	if ( hCmd->pBuffer == NULL )
		goto _ERROR ;
	if ( fgets( hCmd->pBuffer, BUFSIZE, stdin ) == NULL )
		goto _ERROR ;

	/* R}hC\ */
	for ( bRead = 0, bDQuate = 0, i = 0 ; i < BUFSIZE-1 ; i ++ )
	{
		char	c = hCmd->pBuffer[i] ;
		if ( c == '\r' || c == '\n' || c == '\0' )
		{
			if ( bRead )
			{
				hCmd->pBuffer[i] = '\0' ;
				hCmd->argc ++ ;
			}
			break ;
		}

		if ( IsSJISLeadByte( c ) )
		{
			if ( !bRead )
			{
				hCmd->argv[hCmd->argc] = hCmd->pBuffer + i ;
				bRead = 1 ;
			}
			i ++ ;
		}
		else
		{
			if ( !bRead )
			{
				if ( c == '\"' )
				{
					hCmd->argv[hCmd->argc] = hCmd->pBuffer + i + 1 ;
					bRead = 1 ;
					bDQuate = 1 ;
				}
				else if ( c != ' ' )
				{
					hCmd->argv[hCmd->argc] = hCmd->pBuffer + i ;
					bRead = 1 ;
				}
			}
			else
			{
				if ( bDQuate )
				{
					if ( c == '\"' )
					{
						hCmd->pBuffer[i] = '\0' ;
						hCmd->argc ++ ;
						bRead = 0 ;
						bDQuate = 0 ;
					}
				}
				else if ( c == ' ' )
				{
					hCmd->pBuffer[i] = '\0' ;
					hCmd->argc ++ ;
					bRead = 0 ;
				}
			}
		}
	}
	return hCmd ;

_ERROR:
	if ( hCmd != NULL )
	{
		if ( hCmd->pBuffer != NULL )
			free( hCmd->pBuffer ) ;
		free( hCmd ) ;
	}
	return NULL ;
}

static void cmd_release( HCMD hCmd )
{
	assert( hCmd != NULL ) ;
	free( hCmd->pBuffer ) ;
	free( hCmd ) ;
}

int cmd_argc( HCMD hCmd )
{
	assert( hCmd != NULL ) ;
	return hCmd->argc ;
}

const char * cmd_argv( HCMD hCmd, int index )
{
	assert( hCmd != NULL ) ;
	assert( index < hCmd->argc ) ;
	return hCmd->argv[index] ;
}

void cmd_loop( const char * pszPrompt, const CMDINFO * pCmdMap, int cmdNum, void * pUserData )
{
	assert( pszPrompt != NULL ) ;
	assert( pCmdMap != NULL ) ;
	for ( ; ; )
	{
		HCMD			hCmd ;
		const char *	pszCmdName ;
		int				i ;

		printf( pszPrompt ) ;
		hCmd = cmd_get() ;
		if ( hCmd == NULL )
			break ;
		if ( cmd_argc( hCmd ) == 0 )
		{
			cmd_release( hCmd ) ;
			continue ;
		}
		pszCmdName = cmd_argv( hCmd, 0 ) ;
		for ( i = 0 ; i < cmdNum ; i ++ )
		{
			if ( strcmp( pszCmdName, pCmdMap[i].pszName ) == 0 )
			{
				if ( pCmdMap[i].handler( hCmd, pUserData ) )
				{
					cmd_release( hCmd ) ;
					return ;
				}
				cmd_release( hCmd ) ;
				hCmd = NULL ;
				break ;
			}
		}
		if ( hCmd != NULL )
		{
			printf( "R}hꗗ\n" ) ;
			for ( i = 0 ; i < cmdNum ; i ++ )
				printf( "\t%s\n", pCmdMap[i].pszName ) ;
			cmd_release( hCmd ) ;
			hCmd = NULL ;
		}
	}
}






